<?php  // $Id: enrol.php,v 1.7 2005/02/08 17:56:18 moodler Exp $

require_once("$CFG->dirroot/enrol/enrol.class.php");

class enrolment_plugin extends enrolment_base {

    var $log;    

/// Leave get_teacher_courses() function unchanged for the time being

/// Leave get_student_courses() function unchanged for the time being

/// Overide the base cron() function

    function cron() {
        global $CFG;

        /// call the base class
        parent::cron();
        
        
        echo "Running enrolment. \n";
        
        $select = "$CFG->augdatabase_localuserfield != ' ' and deleted = 0 order by username";
        
	if ($students = get_records_select('user', $select)){
	
	foreach ($students as $user) {

    parent::get_student_courses($user);  /// Start with the list of known enrolments
                                         /// If the database fails we can at least use this
    echo $user->username." = ";
     
         // This is a hack to workaround what seems to be a bug in ADOdb with accessing 
    // two databases of the same kind ... it seems to get confused when trying to access
    // the first database again, after having accessed the second.
    // The following hack will make the database explicit which keeps it happy

    if (strpos($CFG->prefix, $CFG->dbname) === false) {
        $oldprefix = $CFG->prefix;
        $CFG->prefix = "$CFG->dbname.$CFG->prefix";
    }

    // Try to connect to the external database

    $enroldb = &ADONewConnection($CFG->augdatabase_dbtype);

    if ($enroldb->PConnect($CFG->augdatabase_dbhost,$CFG->augdatabase_dbuser,$CFG->augdatabase_dbpass,$CFG->augdatabase_dbname)) {

        $courselist = array();      /// Initialise new array
        $newstudent = array();

        /// Get the authoritative list of enrolments from the database

        $useridnumber = $user->{$CFG->augdatabase_localuserfield};   
		
		echo "[".$useridnumber."] => ";

			/// Union on the two enollment tables

	        if ($rs = $enroldb->Execute("SELECT `$CFG->augdatabase_remotecoursefield` 
                                       FROM `$CFG->augdatabase_dbtable` 
                                      WHERE `$CFG->augdatabase_remoteuserfield` = '$useridnumber' 
                                      UNION
                                      SELECT `$CFG->augdatabase_remoteexceptcoursefield`
                                      FROM `$CFG->augdatabase_remoteexcepttable`
                                      WHERE `$CFG->augdatabase_remoteexceptuserfield` = '$useridnumber'")) {

            if ($rs->RecordCount() > 0) {
                while (!$rs->EOF) {
                    $courselist[] = $rs->fields[0];
                    $rs->MoveNext();
                }

            echo $rs->RecordCount()." courses: ";

                foreach ($courselist as $coursefield) {

 					echo "| ";
 
                     /// look in remote CMS table for the course
                    /// if listed, it will be only once, use that courseid for the moodle one, otherwise stay as it
                	if ($cms = $enroldb->Execute("SELECT `$CFG->augdatabase_remoteconvertcms`
                								  FROM `$CFG->augdatabase_remoteconverttable`
                								  WHERE `$CFG->augdatabase_remoteconvertregistrar` = '$coursefield'")) {
                								  if ($cms->RecordCount() > 0) {
                								  echo "translate ".$coursefield." to ";
                								     $coursefield = $cms->fields[0];
                								  }
                								               								  
                	 }

 
                echo " ".$coursefield." ";

                    if ($course = get_record('course', $CFG->augdatabase_localcoursefield, $coursefield)) {
                        echo "found course mdlid=".$course->id." ";
                        $newstudent[$course->id] = true;             /// Add it to new list
                        if (isset($user->student[$course->id])) {   /// We have it already
                            unset($user->student[$course->id]);       /// Remove from old list
                            echo " already enroled ";
                        } else {
                            enrol_student($user->id, $course->id, 0, 0, 'augdatabase');   /// Enrol the student
                            echo " enrolling in ".$course->id." \n";                            
                        }
                    }
                }
            }

            if (!empty($user->student)) {    /// We have some courses left that we need to unenrol from
                foreach ($user->student as $courseid => $value) {
                echo "I want to unenrol ".$courseid." ";
                // only unenrol if the person was an augdatabase enrolee, auto won't remove a manual enrol
                $selection = "userid = ".$user->id." and course=".$courseid." and enrol = 'augdatabase'";
                if(get_record_select(user_students,$selection)) {
                    echo " unenroling from ".$courseid;
                    unenrol_student($user->id, $courseid);       /// Unenrol the student
                    unset($user->student[$course->id]);           /// Remove from old list
                   }
                
                }
            }

            $user->student = $newstudent;    /// Overwrite the array with the new one
        }
        
        $enroldb->Close();
    }
    
    else { echo "DB connect failed!"; }

    if (!empty($oldprefix)) {
        $CFG->prefix = $oldprefix;           // Restore it just in case
    }

     
    echo "\n"; 
    }
    } 
    echo "!\n";
     
}


/// Override the base print_entry() function
function print_entry($course) {
    global $CFG;

    if (! empty($CFG->enrol_allowinternal) ) {
        parent::print_entry($course);
    } else {
        print_header();
        notice(get_string("enrolmentnointernal"), $CFG->wwwroot);
    }
}


/// Override the base check_entry() function
function check_entry($form, $course) {
    global $CFG;

    if (! empty($CFG->enrol_allowinternal) ) {
        parent::check_entry($form, $course);
    }
}


/// Overide the get_access_icons() function
function get_access_icons($course) {
}


/// Overide the base config_form() function
function config_form($frm) {
    global $CFG;

    $vars = array('augdatabase_dbhost', 'augdatabase_dbuser', 'augdatabase_dbpass', 
                  'augdatabase_dbname', 'augdatabase_dbtable', 
                  'augdatabase_localcoursefield', 'augdatabase_localuserfield', 
                  'augdatabase_remotecoursefield', 'augdatabase_remoteuserfield',
                  'augdatabase_allowinternal','augdatabase_remoteconverttable',
                  'augdatabase_remoteconvertregistrar','augdatabase_remoteconvertcms',
                  'augdatabase_remoteexcepttable','augdatabase_remoteexceptuserfield',
                  'augdatabase_remoteexceptcoursefield');
    foreach ($vars as $var) {
        if (!isset($frm->$var)) {
            $frm->$var = '';
        } 
    }
    include("$CFG->dirroot/enrol/augdatabase/config.html");
}

/// Override the base process_config() function
function process_config($config) {

    if (!isset($config->augdatabase_dbtype)) {
        $config->augdatabase_dbtype = 'mysql';
    }
    set_config('augdatabase_dbtype', $config->augdatabase_dbtype);

    if (!isset($config->augdatabase_dbhost)) {
        $config->augdatabase_dbhost = '';
    }
    set_config('augdatabase_dbhost', $config->augdatabase_dbhost);

    if (!isset($config->augdatabase_dbuser)) {
        $config->augdatabase_dbuser = '';
    }
    set_config('augdatabase_dbuser', $config->augdatabase_dbuser);

    if (!isset($config->augdatabase_dbpass)) {
        $config->augdatabase_dbpass = '';
    }
    set_config('augdatabase_dbpass', $config->augdatabase_dbpass);

    if (!isset($config->augdatabase_dbname)) {
        $config->augdatabase_dbname = '';
    }
    set_config('augdatabase_dbname', $config->augdatabase_dbname);

    if (!isset($config->augdatabase_dbtable)) {
        $config->augdatabase_dbtable = '';
    }
    set_config('augdatabase_dbtable', $config->augdatabase_dbtable);

    if (!isset($config->augdatabase_localcoursefield)) {
        $config->augdatabase_localcoursefield = '';
    }
    set_config('augdatabase_localcoursefield', $config->augdatabase_localcoursefield);

    if (!isset($config->augdatabase_localuserfield)) {
        $config->augdatabase_localuserfield = '';
    }
    set_config('augdatabase_localuserfield', $config->augdatabase_localuserfield);

    if (!isset($config->augdatabase_remotecoursefield)) {
        $config->augdatabase_remotecoursefield = '';
    }
    set_config('augdatabase_remotecoursefield', $config->augdatabase_remotecoursefield);

    if (!isset($config->augdatabase_remoteuserfield)) {
        $config->augdatabase_remoteuserfield = '';
    }
    set_config('augdatabase_remoteuserfield', $config->augdatabase_remoteuserfield);

    if (!isset($config->augdatabase_remoteconverttable)) {
        $config->augdatabase_remoteconverttable = '';
    }
    set_config('augdatabase_remoteconverttable', $config->augdatabase_remoteconverttable);
    
    if (!isset($config->augdatabase_remoteconvertregistrar)) {
        $config->augdatabase_remoteconvertregistrar = '';
    }
    set_config('augdatabase_remoteconvertregistrar', $config->augdatabase_remoteconvertregistrar);
    
    if (!isset($config->augdatabase_remoteconvertcms)) {
        $config->augdatabase_remoteconvertcms = '';
    }
    set_config('augdatabase_remoteconvertcms', $config->augdatabase_remoteconvertcms);
    
    if (!isset($config->augdatabase_remoteexcepttable)) {
        $config->augdatabase_remoteexcepttable = '';
    }
    set_config('augdatabase_remoteexcepttable', $config->augdatabase_remoteexcepttable);    

    if (!isset($config->augdatabase_remoteexceptuserfield)) {
        $config->augdatabase_remoteexceptuserfield = '';
    }
    set_config('augdatabase_remoteexceptuserfield', $config->augdatabase_remoteexceptuserfield);

    if (!isset($config->augdatabase_remoteexceptcoursefield)) {
        $config->augdatabase_remoteexceptcoursefield = '';
    }
    set_config('augdatabase_remoteexceptcoursefield', $config->augdatabase_remoteexceptcoursefield);

    if (!isset($config->enrol_allowinternal)) {
        $config->enrol_allowinternal = '';
    }
    set_config('enrol_allowinternal', $config->enrol_allowinternal);
    
    return true;

}



} // end of class

?>